> For the complete documentation index, see [llms.txt](https://docs.syncswap.xyz/api-documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.syncswap.xyz/api-documentation/core-architecture/pool-factory.md).

# Pool Factory

There will be one Pool Factory for each type of pool, and the factory will be used to create pools for the pool type. The factory implementations will then register the newly created pool to the Pool Master.

## Interface

```solidity

// The standard interface.
interface IPoolFactory {
    function master() external view returns (address);
    
    function getDeployData() external view returns (bytes memory);

    // Call the function with data to create a pool.
    // For base pool factories, the data is as follows.
    // `(address tokenA, address tokenB) = abi.decode(data, (address, address));`
    function createPool(bytes calldata data) external returns (address pool);
}

// The interface for base pools has two tokens.
interface IBasePoolFactory is IPoolFactory {
    event PoolCreated(
        address indexed token0,
        address indexed token1,
        address pool
    );

    function getPool(address tokenA, address tokenB) external view returns (address pool);

    // [Deprecated] This is the interface before the dynamic fees update.
    // This function will forward calls to the pool master.
    //function getSwapFee(address pool) external view returns (uint24 swapFee);
    
    // [Recommended] This is the latest interface.
    // This function will forward calls to the pool master.
    function getSwapFee(
        address pool,
        address sender,
        address tokenIn,
        address tokenOut,
        bytes calldata data
    ) external view override returns (uint24 swapFee) {
        swapFee = IPoolMaster(master).getSwapFee(pool, sender, tokenIn, tokenOut, data);
    }
}

```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.syncswap.xyz/api-documentation/core-architecture/pool-factory.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
